Package org.apache.tomcat.util.net.openssl

## Class OpenSSLUtil

- java.lang.Object
- - org.apache.tomcat.util.net.SSLUtilBase
  - - org.apache.tomcat.util.net.openssl.OpenSSLUtil

All Implemented Interfaces:
  `SSLUtil`

    public class OpenSSLUtil
    extends SSLUtilBase

### Nested Class Summary

### Nested classes/interfaces inherited from interface org.apache.tomcat.util.net.SSLUtil

`SSLUtil.ProtocolInfo`

### Field Summary

### Fields inherited from class org.apache.tomcat.util.net.SSLUtilBase

`certificate, DEFAULT_KEY_ALIAS, sslHostConfig`

### Constructor Summary

Constructors
`OpenSSLUtil​(SSLHostConfigCertificate certificate)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static javax.net.ssl.X509KeyManager` `chooseKeyManager​(javax.net.ssl.KeyManager[] managers)`
`SSLContext` `createSSLContextInternal​(java.util.List<java.lang.String> negotiableProtocols)`
`protected java.util.Set<java.lang.String>` `getImplementedCiphers()`
`protected java.util.Set<java.lang.String>` `getImplementedProtocols()`
`javax.net.ssl.KeyManager[]` `getKeyManagers()`
`protected Log` `getLog()`
`protected boolean` `isTls13RenegAuthAvailable()`

### Methods inherited from class org.apache.tomcat.util.net.SSLUtilBase

`configureSessionContext, createSSLContext, getCRLs, getEnabledCiphers, getEnabledProtocols, getParameters, getTrustManagers`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### OpenSSLUtil

    public OpenSSLUtil​(SSLHostConfigCertificate certificate)

### Method Detail

#### getLog

    protected Log getLog()

Specified by:
  `getLog` in class `SSLUtilBase`

#### getImplementedProtocols

    protected java.util.Set<java.lang.String> getImplementedProtocols()

Specified by:
  `getImplementedProtocols` in class `SSLUtilBase`

#### getImplementedCiphers

    protected java.util.Set<java.lang.String> getImplementedCiphers()

Specified by:
  `getImplementedCiphers` in class `SSLUtilBase`

#### isTls13RenegAuthAvailable

    protected boolean isTls13RenegAuthAvailable()

Specified by:
  `isTls13RenegAuthAvailable` in class `SSLUtilBase`

#### createSSLContextInternal

    public SSLContext createSSLContextInternal​(java.util.List<java.lang.String> negotiableProtocols)
                                        throws java.lang.Exception

Specified by:
  `createSSLContextInternal` in class `SSLUtilBase`
Throws:
  `java.lang.Exception`

#### chooseKeyManager

    public static javax.net.ssl.X509KeyManager chooseKeyManager​(javax.net.ssl.KeyManager[] managers)
                                                         throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### getKeyManagers

    public javax.net.ssl.KeyManager[] getKeyManagers()
                                              throws java.lang.Exception

Specified by:
  `getKeyManagers` in interface `SSLUtil`
Overrides:
  `getKeyManagers` in class `SSLUtilBase`
Throws:
  `java.lang.Exception`